Index: src/map/skill.c
===================================================================
--- src/map/skill.c (revision 23)
+++ src/map/skill.c (revision 24)
@@ -9552,5 +9557,5 @@
 	return count;
 }
-
+	
 /*==========================================
  * Returns the first element field found [Skotlex]
@@ -9706,5 +9711,5 @@
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 int skill_chastle_mob_changetarget(struct block_list *bl,va_list ap)
@@ -9739,5 +9744,5 @@
 	unit = (struct skill_unit *)src;
 	tick = va_arg(ap,int);
-
+	
 	nullpo_retr(0, sg = unit->group);
 	nullpo_retr(0, ss = map_id2bl(sg->src_id));
@@ -9749,5 +9754,5 @@
 		case UNT_SHOCKWAVE:
 		case UNT_SANDMAN:
-		case UNT_FLASHER:
+		case UNT_FLASHER:        
 			skill_additional_effect(ss,bl,sg->skill_id,sg->skill_lv,BF_MISC,tick);
 			break;
@@ -9795,5 +9800,5 @@
 		if (type != scs[i] && sc->data[scs[i]])
 			status_change_end(bl, scs[i], -1);
-
+		
 	return 0;
 }
@@ -9813,5 +9818,5 @@
 			wall = false;
 	}
-
+		
 	if( sce )
 	{
@@ -9856,8 +9861,8 @@
 	if(!sc->count || !(sce=sc->data[SC_DANCING]))
 		return;
-
+	
 	group = (struct skill_unit_group *)sce->val2;
 	sce->val2 = 0;
-
+	
 	if (sce->val4)
 	{
@@ -9993,5 +9998,5 @@
 	nullpo_retr(NULL, src);
 	nullpo_retr(NULL, ud);
-
+	
 	// find a free spot to store the new unit group
 	ARR_FIND( 0, MAX_SKILLUNITGROUP, i, ud->skillunit[i] == NULL );
@@ -10053,8 +10058,8 @@
 
 	if (!src) src=map_id2bl(group->src_id);
-	ud = unit_bl2ud(src);
+	ud = unit_bl2ud(src);	
 	if(!src || !ud) {
 		ShowError("skill_delunitgroup: Group's source not found! (src_id: %d skill_id: %d)\n", group->src_id, group->skill_id);
-		return 0;
+		return 0;	
 	}
 	if (skill_get_unit_flag(group->skill_id)&(UF_DANCE|UF_SONG|UF_ENSEMBLE))
@@ -10152,5 +10157,5 @@
 	if (group->interval==-1)
 		return NULL;
-
+	
 	ud = unit_bl2ud(bl);
 	if (!ud) return NULL;
@@ -10394,7 +10399,7 @@
 	int skill_id;
 	int i;
-
+	
 	nullpo_retr(0, group);
-
+	
 	if( !unit->alive || target->prev == NULL )
 		return 0;
@@ -10475,5 +10480,5 @@
 		//cells do not get deleted within them. [Skotlex]
 		if( dissonance ) skill_dance_switch(unit, 1);
-
+			
 		if( flag&4 )
 			skill_unit_onleft(skill_id,target,tick);
@@ -10502,5 +10507,5 @@
 		memset(skill_unit_temp, 0, sizeof(skill_unit_temp));
 	}
-
+		
 	map_foreachincell(skill_unit_move_sub,bl->m,bl->x,bl->y,BL_SKILL,bl,tick,flag);
 
@@ -10680,8 +10685,8 @@
 	if (qty < 1)
 		qty = 1;
-
+	
 	if (!skill_id) //A skill can be specified for some override cases.
 		skill_id = skill_produce_db[idx].req_skill;
-
+	
 	slot[0]=slot1;
 	slot[1]=slot2;
@@ -10761,28 +10766,20 @@
 			case AM_TWILIGHT2:
 			case AM_TWILIGHT3:
-				make_per = pc_checkskill(sd,AM_LEARNINGPOTION)*100
+				make_per = pc_checkskill(sd,AM_LEARNINGPOTION)*50
 					+ pc_checkskill(sd,AM_PHARMACY)*300 + sd->status.job_level*20
-					+ status->int_*5 + status->dex*10+status->luk*10;
+					+ (status->int_/2)*10 + status->dex*10+status->luk*10;
+				if(merc_is_hom_active(sd->hd)) {//Player got a homun
+					int skill;
+					if((skill=merc_hom_checkskill(sd->hd,HVAN_INSTRUCT)) > 0) //His homun is a vanil with instruction change
+						make_per += skill*100; //+1% bonus per level
+				}
 				switch(nameid){
 					case 501: // Red Potion
 					case 503: // Yellow Potion
 					case 504: // White Potion
-					case 605: // Anodyne
-					case 606: // Aloevera
-						make_per += 2000;
+						make_per += (1+rand()%100)*10 + 2000;
 						break;
-					case 505: // Blue Potion
-						make_per -= 500;
-						break;
-					case 545: // Condensed Red Potion
-					case 546: // Condensed Yellow Potion
-					case 547: // Condensed White Potion
-						make_per -= 1000;
-					    break;
-				 	case 970: // Alcohol
-						make_per += 1000;
-						break;
-					case 7139: // Glistening Coat
-						make_per -= 1000;
+					case 970: // Alcohol
+						make_per += (1+rand()%100)*10 + 1000;
 						break;
 					case 7135: // Bottle Grenade
@@ -10790,4 +10787,18 @@
 					case 7137: // Plant Bottle
 					case 7138: // Marine Sphere Bottle
+						make_per += (1+rand()%100)*10;
+						break;
+					case 546: // Condensed Yellow Potion
+						make_per -= (1+rand()%50)*10;
+						break;
+					case 547: // Condensed White Potion
+					case 7139: // Glistening Coat
+						make_per -= (1+rand()%100)*10;
+					    break;
+					//Common items, recieve no bonus or penalty, listed just because they are commonly produced
+					case 505: // Blue Potion
+					case 545: // Condensed Red Potion
+					case 605: // Anodyne
+					case 606: // Aloevera
 					default:
 						break;
@@ -10827,9 +10838,9 @@
 // - Baby Class Penalty = 80% (from adult's chance) ----//
 	if (sd->class_&JOBL_BABY) //if it's a Baby Class
-		make_per = (make_per * 80) / 100; //Lupus
+		make_per = (make_per * 70) / 100; //Baby penalty is 30%
 
 	if(make_per < 1) make_per = 1;
 
-
+	
 	if(rand()%10000 < make_per || qty > 1){ //Success, or crafting multiple items.
 		struct item tmp_item;
@@ -10902,5 +10913,5 @@
 						skill_id != AM_TWILIGHT2 &&
 						skill_id != AM_TWILIGHT3)
-						continue;
+						continue;						
 					//Add fame as needed.
 					switch(++sd->potion_success_counter) {
@@ -10955,5 +10966,5 @@
 		}
 	}
-	//Failure
+	//Failure	
 //	if(log_config.produce)
 //		log_produce(sd,nameid,slot1,slot2,slot3,0);
@@ -11041,5 +11052,5 @@
 		return 0;
 	if (sd) sd->blockskill[data] = 0;
-
+	
 	return 1;
 }
@@ -11068,5 +11079,5 @@
 		return 0;
 	if (hd) hd->blockskill[data] = 0;
-
+	
 	return 1;
 }
@@ -11075,5 +11086,5 @@
 {
 	nullpo_retr (-1, hd);
-
+	
 	skillid = skill_get_index(skillid);
 	if (skillid == 0)
@@ -11135,8 +11146,8 @@
 			if ((val[j]-val[j-step]) != diff)
 				break;
-
+	
 		if (j>=step) //No match, try next step.
 			continue;
-
+		
 		for(; i < MAX_SKILL_LEVEL; i++)
 		{	//Apply linear increase
@@ -11335,6 +11346,6 @@
 				memcpy(skill_unit_layout[pos].dy,dy,sizeof(dy));
 			} else {
-				int dx[] = { 1, 1 ,0, 0,-1};
-				int dy[] = { 1, 0, 0,-1,-1};
+				int dx[] = { 1, 1 ,0, 0,-1}; 
+				int dy[] = { 1, 0, 0,-1,-1}; 
 				memcpy(skill_unit_layout[pos].dx,dx,sizeof(dx));
 				memcpy(skill_unit_layout[pos].dy,dy,sizeof(dy));
@@ -11366,6 +11377,6 @@
 				memcpy(skill_unit_layout[pos].dy,dy,sizeof(dy));
 			} else {
-				int dx[] = { 2, 1 ,0,-1,-2};
-				int dy[] = { 2, 1, 0,-1,-2};
+				int dx[] = { 2, 1 ,0,-1,-2}; 
+				int dy[] = { 2, 1, 0,-1,-2}; 
 				memcpy(skill_unit_layout[pos].dx,dx,sizeof(dx));
 				memcpy(skill_unit_layout[pos].dy,dy,sizeof(dy));
@@ -11396,5 +11407,5 @@
  * skill_nocast_db.txt
  * skill_unit_db.txt
- * produce_db.txt
+ * produce_db.txt 
  * create_arrow_db.txt
  * abra_db.txt
@@ -11465,5 +11476,5 @@
 	skill_split_atoi(split[5],skill_db[i].sp_rate);
 	skill_split_atoi(split[6],skill_db[i].zeny);
-
+	
 	//FIXME: document this
 	p = split[7];
@@ -11483,5 +11494,5 @@
 		p++;
 	}
-
+	
 	//FIXME: document this
 	p = split[8];
@@ -11517,5 +11528,5 @@
 	else if( strcmpi(split[10],"water")==0 ) skill_db[i].state = ST_WATER;
 	else skill_db[i].state = ST_NONE;
-
+	
 	skill_split_atoi(split[11],skill_db[i].spiritball);
 	for( j = 0; j < 10; j++ ) {
@@ -11533,5 +11544,5 @@
 	if( !i ) // invalid skill id
 		return false;
-
+	
 	skill_split_atoi(split[1],skill_db[i].cast);
 	skill_split_atoi(split[2],skill_db[i].delay);
@@ -11549,5 +11560,5 @@
 	if( !i ) // invalid skill id
 		return false;
-
+	
 	skill_split_atoi(split[1],skill_db[i].castnodex);
 	if( split[2] ) // optional column
@@ -11575,5 +11586,5 @@
 	if( !i ) // invalid skill id
 		return false;
-
+	
 	skill_db[i].unit_id[0] = strtol(split[1],NULL,16);
 	skill_db[i].unit_id[1] = strtol(split[2],NULL,16);
@@ -11621,5 +11632,5 @@
 	skill_produce_db[current].req_skill = atoi(split[2]);
 	skill_produce_db[current].req_skill_lv = atoi(split[3]);
-
+	
 	for( x = 4, y = 0; x+1 < columns && split[x] && split[x+1] && y < MAX_PRODUCE_RESOURCE; x += 2, y++ )
 	{
@@ -11640,5 +11651,5 @@
 
 	skill_arrow_db[current].nameid = i;
-
+	
 	for( x = 1, y = 0; x+1 < columns && split[x] && split[x+1] && y < MAX_ARROW_RESOURCE; x += 2, y++ )
 	{
@@ -11679,5 +11690,5 @@
 	memset(skill_arrow_db,0,sizeof(skill_arrow_db));
 	memset(skill_abra_db,0,sizeof(skill_abra_db));
-
+	
 	// load skill databases
 	safestrncpy(skill_db[0].name, "UNKNOWN_SKILL", sizeof(skill_db[0].name));
@@ -11707,8 +11718,8 @@
 	skilldb_name2id = strdb_alloc(DB_OPT_DUP_KEY, 0);
 	skill_readdb();
-
+	
 	skill_unit_ers = ers_new(sizeof(struct skill_unit_group));
 	skill_timer_ers  = ers_new(sizeof(struct skill_timerskill));
-
+	
 	add_timer_func_list(skill_unit_timer,"skill_unit_timer");
 	add_timer_func_list(skill_castend_id,"skill_castend_id");
@@ -11716,5 +11727,5 @@
 	add_timer_func_list(skill_timerskill,"skill_timerskill");
 	add_timer_func_list(skill_blockpc_end, "skill_blockpc_end");
-
+	
 	add_timer_interval(gettick()+SKILLUNITTIMER_INTERVAL,skill_unit_timer,0,0,SKILLUNITTIMER_INTERVAL);
 
@@ -11729,5 +11740,5 @@
 	return 0;
 }
-
+//Why is this after the cleanup code?
 int skill_additem(struct block_list* src, struct block_list *bl, int itemid, int amount)// ITEM GIVER [Brain]
 {
@@ -11735,21 +11746,21 @@
 
 	nullpo_retr(1, src);
-	nullpo_retr(1, bl);
+	nullpo_retr(1, bl);	
 
 	if (src->m != bl->m)
-	return 1;
+		return 1;
 	if (bl->prev == NULL)
-	return 1;
+		return 1;
 	if (src->type == BL_PC)
-	sd = (struct map_session_data *)src;
+		sd = (struct map_session_data *)src;
 	if (bl->type == BL_PC)
-	tsd = (struct map_session_data *)bl;
+		tsd = (struct map_session_data *)bl;
 	if (status_isdead(bl))
-	return 1;
+		return 1;
 
 	int eflag;
 	struct item item_tmp;
 	struct block_list tbl;
-
+	
 	memset(&item_tmp,0,sizeof(item_tmp));
 	memset(&tbl,0,sizeof(tbl));
@@ -11762,6 +11773,6 @@
 	eflag = pc_additem(sd,&item_tmp,amount);
 	if(eflag) {
-	clif_additem(sd,0,0,eflag);
-	map_addflooritem(&item_tmp,amount,sd->bl.m,sd->bl.x,sd->bl.y,0,0,0,0);
+		clif_additem(sd,0,0,eflag);
+		map_addflooritem(&item_tmp,amount,sd->bl.m,sd->bl.x,sd->bl.y,0,0,0,0);
 	}
 	return 0;
Index: src/map/unit.c
===================================================================
--- src/map/unit.c (revision 22)
+++ src/map/unit.c (revision 24)
@@ -374,8 +374,6 @@
 	if (sc && sc->data[SC_CONFUSION]) //Randomize the target position
 		map_random_dir(bl, &ud->to_x, &ud->to_y);
-
 	if (sc && sc->data[SC_FEAR]) //Flee from my target [Brainstorm]
-	unit_escape(bl, tbl, 15);
-
+		unit_escape(bl, tbl, 15);
 
 	if(ud->walktimer != -1) {
@@ -1091,6 +1089,6 @@
 	if(casttime > 0) {
 		ud->skilltimer = add_timer( tick+casttime, skill_castend_id, src->id, 0 );
-		if(sd && pc_checkskill(sd,SA_FREECAST))
-			status_freecast_switch(sd);
+		if( sd && pc_checkskill(sd,SA_FREECAST) > 0 )
+			status_calc_bl(&sd->bl, SCB_SPEED);
 		else
 			unit_stop_walking(src,1);
@@ -1192,6 +1190,6 @@
 	if(casttime > 0) {
 		ud->skilltimer = add_timer( tick+casttime, skill_castend_pos, src->id, 0 );
-		if(sd && pc_checkskill(sd,SA_FREECAST))
-			status_freecast_switch(sd);
+		if( sd && pc_checkskill(sd,SA_FREECAST) > 0 )
+			status_calc_bl(&sd->bl, SCB_SPEED);
 		else
 			unit_stop_walking(src,1);
@@ -1525,8 +1523,6 @@
 	}
 	
-	ud->canact_tick=tick;
-	if(sd && pc_checkskill(sd,SA_FREECAST))
-		status_freecast_switch(sd);
-	
+	ud->canact_tick = tick;
+
 	if(type&1 && sd)
 		skill = sd->skillid_old;
@@ -1540,8 +1536,12 @@
 	if(ret<0)
 		ShowError("delete timer error : skillid : %d\n",ret);
-	
+
+	ud->skilltimer = -1;
+
+	if( sd && pc_checkskill(sd,SA_FREECAST) > 0 )
+		status_calc_bl(&sd->bl, SCB_SPEED);
+
 	if(bl->type==BL_MOB) ((TBL_MOB*)bl)->skillidx  = -1;
 
-	ud->skilltimer = -1;
 	clif_skillcastcancel(bl);
 	return 1;
Index: src/map/battle.h
===================================================================
--- src/map/battle.h (revision 19)
+++ src/map/battle.h (revision 24)
@@ -88,4 +88,5 @@
 
 int battle_check_undead(int race,int element);
+// seems fine.
 int battle_check_living(int race,int element);	//Living Creature Check [Brain]
 int battle_check_target(struct block_list *src, struct block_list *target,int flag);
@@ -453,8 +454,10 @@
 	int auction_feeperhour;
 	int auction_maximumprice;
+//Declares the conf reader should check for these
 	//Vanaheim battle settings [Brainstorm]
 	int necro_retaliation; //Battle flag to force monsters to attack adept/necro/warlock summons [Brain]
 	int disp_summon_stats; //Battle Flag to show summoned monster stats [Brain]
 	int gm_viewequip_min_lv;
+	int homunculus_auto_vapor; //Keep Homunculus from Vaporizing when master dies. [L0ne_W0lf]
 } battle_config;
 
